#include "itkNDLoop.h"
#include <iostream>
#include <vector>

using namespace std;

/************************************
 *
 *    This is the Index class
 *
 ************************************/

typedef vector<unsigned int > myIndexType;



/************************************
 *
 *    This is the functor class
 *
 ************************************/

template < class Index >
class printIndex 
{
public:
  void operator()( const Index & index ) const
  {
    
    typename Index::const_iterator ind = index.begin();
    while ( ind != index.end() ) 
    {
      cout << *ind << " ";
      ind++;
    }
    cout << endl;
  }
};


typedef printIndex< myIndexType > myAction;


int main() 
{
  
  myIndexType begin;
  myIndexType end;

  begin.push_back(0);
  begin.push_back(0);
  begin.push_back(0);

  end.push_back(3);
  end.push_back(3);
  end.push_back(3);

  myAction action;
  ForAll < myIndexType, myAction >  myLoop;
  myLoop.DoInRegion ( begin , end , action );
  return 0;
}


