
#ifndef itkNDLoop_h
#define itkNDLoop_h

template <class Index, class Functor >
class ForAll {
public:
  void DoInRegion ( const Index & begin, 
                    const Index & end, 
                    const Functor & action ) {

  Index index;
  index = begin;

  const unsigned int N = begin.size();

  bool remaining = true;
  while ( remaining ) 
  {

    // Go through the inner loop
    for ( unsigned int i=0; i<end[0]; i++ ) 
    {
      
      action( index );  // do something in the inner loop
      index[0]++;       // advance
    }


    // Update higher dimensions
    for ( unsigned int n=1; n<N; n++ ) 
    {
      index[n-1]=0;  
      index[n]++;
      remaining = false;
      if ( index[n] < end[n] )
      {
        remaining = true;
        break;
      }
    }
    
  }
}

};




#endif

